<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::MeshCoP::Dtls Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="../../d4/d83/classThread_1_1MeshCoP_1_1Dtls-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::MeshCoP::Dtls Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Collaboration diagram for Thread::MeshCoP::Dtls:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d27/classThread_1_1MeshCoP_1_1Dtls__coll__graph.png" border="0" usemap="#Thread_1_1MeshCoP_1_1Dtls_coll__map" alt="Collaboration graph"/></div>
<map name="Thread_1_1MeshCoP_1_1Dtls_coll__map" id="Thread_1_1MeshCoP_1_1Dtls_coll__map">
<area shape="rect" id="node2" href="../../da/dc7/classThread_1_1MeshCoP_1_1ProvisioningUrlTlv.html" title="This class implements Provisioning URL TLV generation and parsing. " alt="" coords="5,80,215,119"/>
<area shape="rect" id="node3" href="../../dd/d8d/classThread_1_1MeshCoP_1_1Tlv.html" title="This class implements MeshCoP TLV generation and parsing. " alt="" coords="33,5,187,31"/>
</map>
<center><span class="legend">[<a target="top" href="../../graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:aed75370dd4965574bff647596b8a4ec1"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aed75370dd4965574bff647596b8a4ec1"></a>enum &#160;</td><td class="memItemRight" valign="bottom">{ <b>kPskMaxLength</b> = 32
 }</td></tr>
<tr class="separator:aed75370dd4965574bff647596b8a4ec1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4549ce46dbb24e3364544f31c344b39"><td class="memItemLeft" align="right" valign="top">typedef void(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#ae4549ce46dbb24e3364544f31c344b39">ReceiveHandler</a>) (void *aContext, uint8_t *aBuf, uint16_t aLength)</td></tr>
<tr class="memdesc:ae4549ce46dbb24e3364544f31c344b39"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pointer is called when data is received from the DTLS session.  <a href="#ae4549ce46dbb24e3364544f31c344b39">More...</a><br /></td></tr>
<tr class="separator:ae4549ce46dbb24e3364544f31c344b39"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46b3f173dd41439e6ab6793a3a384035"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a46b3f173dd41439e6ab6793a3a384035">SendHandler</a>) (void *aContext, const uint8_t *aBuf, uint16_t aLength)</td></tr>
<tr class="memdesc:a46b3f173dd41439e6ab6793a3a384035"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pointer is called when data is ready to transmit for the DTLS session.  <a href="#a46b3f173dd41439e6ab6793a3a384035">More...</a><br /></td></tr>
<tr class="separator:a46b3f173dd41439e6ab6793a3a384035"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a7e61cca52beef79a4a9462d747410182"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a7e61cca52beef79a4a9462d747410182">Dtls</a> (<a class="el" href="../../d3/d8e/classThread_1_1ThreadNetif.html">ThreadNetif</a> &amp;aNetif)</td></tr>
<tr class="memdesc:a7e61cca52beef79a4a9462d747410182"><td class="mdescLeft">&#160;</td><td class="mdescRight">This constructor initializes the DTLS object.  <a href="#a7e61cca52beef79a4a9462d747410182">More...</a><br /></td></tr>
<tr class="separator:a7e61cca52beef79a4a9462d747410182"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd01649bee7d9b91588e9fcde86e6dce"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#afd01649bee7d9b91588e9fcde86e6dce">Start</a> (bool aClient, <a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#ae4549ce46dbb24e3364544f31c344b39">ReceiveHandler</a> aReceiveHandler, <a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a46b3f173dd41439e6ab6793a3a384035">SendHandler</a> aSendHandler, void *aContext)</td></tr>
<tr class="memdesc:afd01649bee7d9b91588e9fcde86e6dce"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method starts the DTLS service.  <a href="#afd01649bee7d9b91588e9fcde86e6dce">More...</a><br /></td></tr>
<tr class="separator:afd01649bee7d9b91588e9fcde86e6dce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a727662d68d1d654c54decad9d8e322f7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a727662d68d1d654c54decad9d8e322f7">Stop</a> (void)</td></tr>
<tr class="memdesc:a727662d68d1d654c54decad9d8e322f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method stops the DTLS service.  <a href="#a727662d68d1d654c54decad9d8e322f7">More...</a><br /></td></tr>
<tr class="separator:a727662d68d1d654c54decad9d8e322f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2a711108e9460beacea0befe482e18fd"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a2a711108e9460beacea0befe482e18fd">IsStarted</a> (void)</td></tr>
<tr class="memdesc:a2a711108e9460beacea0befe482e18fd"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method indicates whether or not the DTLS service is active.  <a href="#a2a711108e9460beacea0befe482e18fd">More...</a><br /></td></tr>
<tr class="separator:a2a711108e9460beacea0befe482e18fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a11d6075b78dadc1d4060988356f7a547"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a11d6075b78dadc1d4060988356f7a547">SetPsk</a> (const uint8_t *aPsk, uint8_t aPskLength)</td></tr>
<tr class="memdesc:a11d6075b78dadc1d4060988356f7a547"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method sets the PSK.  <a href="#a11d6075b78dadc1d4060988356f7a547">More...</a><br /></td></tr>
<tr class="separator:a11d6075b78dadc1d4060988356f7a547"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a53d6ea1746a108d7410b5f8a06fd16ef"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a53d6ea1746a108d7410b5f8a06fd16ef">SetClientId</a> (const uint8_t *aClientId, uint8_t aLength)</td></tr>
<tr class="memdesc:a53d6ea1746a108d7410b5f8a06fd16ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method sets the Client ID used for generating the Hello Cookie.  <a href="#a53d6ea1746a108d7410b5f8a06fd16ef">More...</a><br /></td></tr>
<tr class="separator:a53d6ea1746a108d7410b5f8a06fd16ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aebf42c2d9bcf168be84a8c2204e81f88"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#aebf42c2d9bcf168be84a8c2204e81f88">IsConnected</a> (void)</td></tr>
<tr class="memdesc:aebf42c2d9bcf168be84a8c2204e81f88"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method indicates whether or not the DTLS session is connected.  <a href="#aebf42c2d9bcf168be84a8c2204e81f88">More...</a><br /></td></tr>
<tr class="separator:aebf42c2d9bcf168be84a8c2204e81f88"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7aaea40d39be63eabd938a5cf763d7b3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a7aaea40d39be63eabd938a5cf763d7b3">Send</a> (const uint8_t *aBuf, uint16_t aLength)</td></tr>
<tr class="memdesc:a7aaea40d39be63eabd938a5cf763d7b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method sends data within the DTLS session.  <a href="#a7aaea40d39be63eabd938a5cf763d7b3">More...</a><br /></td></tr>
<tr class="separator:a7aaea40d39be63eabd938a5cf763d7b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6ab4602c1046d668aaba6dfcafe59cfa"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a6ab4602c1046d668aaba6dfcafe59cfa">Receive</a> (<a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;aMessage, uint16_t aOffset, uint16_t aLength)</td></tr>
<tr class="memdesc:a6ab4602c1046d668aaba6dfcafe59cfa"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method provides a received DTLS message to the DTLS object.  <a href="#a6ab4602c1046d668aaba6dfcafe59cfa">More...</a><br /></td></tr>
<tr class="separator:a6ab4602c1046d668aaba6dfcafe59cfa"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a4ae406bedcf14df01ea6cd6d2c1b1dca"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4ae406bedcf14df01ea6cd6d2c1b1dca"></a>
<a class="el" href="../../da/dc7/classThread_1_1MeshCoP_1_1ProvisioningUrlTlv.html">ProvisioningUrlTlv</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a4ae406bedcf14df01ea6cd6d2c1b1dca">mProvisioningUrl</a></td></tr>
<tr class="memdesc:a4ae406bedcf14df01ea6cd6d2c1b1dca"><td class="mdescLeft">&#160;</td><td class="mdescRight">The provisioning URL is placed here so that both the <a class="el" href="../../dc/d67/classThread_1_1MeshCoP_1_1Commissioner.html">Commissioner</a> and <a class="el" href="../../d4/db5/classThread_1_1MeshCoP_1_1Joiner.html">Joiner</a> can share the same object. <br /></td></tr>
<tr class="separator:a4ae406bedcf14df01ea6cd6d2c1b1dca"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a class="anchor" id="ae4549ce46dbb24e3364544f31c344b39"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void(* Thread::MeshCoP::Dtls::ReceiveHandler) (void *aContext, uint8_t *aBuf, uint16_t aLength)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pointer is called when data is received from the DTLS session. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aContext</td><td>A pointer to application-specific context. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aBuf</td><td>A pointer to the received data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aLength</td><td>Number of bytes in the received data buffer. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a46b3f173dd41439e6ab6793a3a384035"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>(* Thread::MeshCoP::Dtls::SendHandler) (void *aContext, const uint8_t *aBuf, uint16_t aLength)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pointer is called when data is ready to transmit for the DTLS session. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aContext</td><td>A pointer to application-specific context. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aBuf</td><td>A pointer to the transmit data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aLength</td><td>Number of bytes in the transmit data buffer. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a7e61cca52beef79a4a9462d747410182"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Thread::MeshCoP::Dtls::Dtls </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d3/d8e/classThread_1_1ThreadNetif.html">ThreadNetif</a> &amp;&#160;</td>
          <td class="paramname"><em>aNetif</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This constructor initializes the DTLS object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aNetif</td><td>A reference to the Thread network interface. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls_a7e61cca52beef79a4a9462d747410182_cgraph.png" border="0" usemap="#d0/d5d/classThread_1_1MeshCoP_1_1Dtls_a7e61cca52beef79a4a9462d747410182_cgraph" alt=""/></div>
<map name="d0/d5d/classThread_1_1MeshCoP_1_1Dtls_a7e61cca52beef79a4a9462d747410182_cgraph" id="d0/d5d/classThread_1_1MeshCoP_1_1Dtls_a7e61cca52beef79a4a9462d747410182_cgraph">
<area shape="rect" id="node2" href="../../da/dc7/classThread_1_1MeshCoP_1_1ProvisioningUrlTlv.html#a446ffcbfca40b7f4244a93165d869a36" title="This method initializes the TLV. " alt="" coords="213,37,423,76"/>
<area shape="rect" id="node3" href="../../dd/d8d/classThread_1_1MeshCoP_1_1Tlv.html#af4de18174724fddc7ac516c219cd16cd" title="This method sets the Type value. " alt="" coords="471,5,626,44"/>
<area shape="rect" id="node4" href="../../dd/d8d/classThread_1_1MeshCoP_1_1Tlv.html#a0524dd75d253e44a53dab3cc0de3393e" title="This method sets the Length value. " alt="" coords="471,68,626,107"/>
</map>
</div>
</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aebf42c2d9bcf168be84a8c2204e81f88"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Thread::MeshCoP::Dtls::IsConnected </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method indicates whether or not the DTLS session is connected. </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">TRUE</td><td>The DTLS session is connected. </td></tr>
    <tr><td class="paramname">FALSE</td><td>The DTLS session is not connected. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2a711108e9460beacea0befe482e18fd"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Thread::MeshCoP::Dtls::IsStarted </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method indicates whether or not the DTLS service is active. </p>
<dl class="section return"><dt>Returns</dt><dd>TRUE if the DTLS service is active, FALSE otherwise. </dd></dl>

</div>
</div>
<a class="anchor" id="a6ab4602c1046d668aaba6dfcafe59cfa"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::MeshCoP::Dtls::Receive </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../dc/d3c/classThread_1_1Message.html">Message</a> &amp;&#160;</td>
          <td class="paramname"><em>aMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aOffset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method provides a received DTLS message to the DTLS object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessage</td><td>A reference to the message. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aOffset</td><td>The offset within <code>aMessage</code> where the DTLS message starts. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aLength</td><td>The size of the DTLS message (bytes).</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully processed the received DTLS message. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls_a6ab4602c1046d668aaba6dfcafe59cfa_cgraph.png" border="0" usemap="#d0/d5d/classThread_1_1MeshCoP_1_1Dtls_a6ab4602c1046d668aaba6dfcafe59cfa_cgraph" alt=""/></div>
<map name="d0/d5d/classThread_1_1MeshCoP_1_1Dtls_a6ab4602c1046d668aaba6dfcafe59cfa_cgraph" id="d0/d5d/classThread_1_1MeshCoP_1_1Dtls_a6ab4602c1046d668aaba6dfcafe59cfa_cgraph">
<area shape="rect" id="node2" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="217,5,381,31"/>
<area shape="rect" id="node4" href="../../d1/d40/classThread_1_1Timer.html#a8815311dffb2fff6b548b63bfc7d6dba" title="This method indicates whether or not the timer instance is running. " alt="" coords="213,55,385,80"/>
<area shape="rect" id="node5" href="../../d1/d40/classThread_1_1Timer.html#a0596072dec177b5e2b494db19800267d" title="This static method returns the current time in milliseconds. " alt="" coords="219,104,379,129"/>
<area shape="rect" id="node7" href="../../d1/d40/classThread_1_1Timer.html#a9acdec1cdf4edf947c563d40871f2bc8" title="This method stops the timer. " alt="" coords="230,153,369,179"/>
<area shape="rect" id="node8" href="../../d1/d40/classThread_1_1Timer.html#a475731e21b59be6b17b24f5b5e175f62" title="This method schedules the timer to fire a dt milliseconds from now. " alt="" coords="229,203,369,228"/>
<area shape="rect" id="node9" href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html#a1669230129da388c39957d064e56cd91" title="This method starts the SHA&#45;256 computation. " alt="" coords="217,252,381,291"/>
<area shape="rect" id="node10" href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html#ab73cec68935d6ea376a717350fbe82e5" title="This method inputs bytes into the SHA&#45;256 computation. " alt="" coords="217,315,381,353"/>
<area shape="rect" id="node11" href="../../d0/dad/classThread_1_1Crypto_1_1Sha256.html#a1b5e941ab243292a8ca7a63dc012a733" title="This method finalizes the hash computation. " alt="" coords="217,377,381,416"/>
<area shape="rect" id="node12" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a25b149621cbd28f9319ee1708ac1f703" title="This method returns a pointer to the key manager object. " alt="" coords="229,440,370,479"/>
<area shape="rect" id="node13" href="../../d6/d44/classThread_1_1KeyManager.html#a728372cc0fe32315d26347e3cfae09d1" title="This method sets the KEK. " alt="" coords="226,503,373,541"/>
<area shape="rect" id="node3" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="433,5,631,31"/>
<area shape="rect" id="node6" href="../../dd/db6/group__alarm.html#gaf8829e3591e03e29e136685fcdeb3300" title="Get the current time. " alt="" coords="463,104,601,129"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a7aaea40d39be63eabd938a5cf763d7b3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::MeshCoP::Dtls::Send </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method sends data within the DTLS session. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aBuf</td><td>A pointer to the data buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aLength</td><td>Number of bytes in the data buffer.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully sent the data via the DTLS session. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a53d6ea1746a108d7410b5f8a06fd16ef"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::MeshCoP::Dtls::SetClientId </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aClientId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method sets the Client ID used for generating the Hello Cookie. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aClientId</td><td>A pointer to the Client ID. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aLength</td><td>Number of bytes in the Client ID.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully set the Client ID. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a11d6075b78dadc1d4060988356f7a547"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::MeshCoP::Dtls::SetPsk </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aPsk</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aPskLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method sets the PSK. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aPSK</td><td>A pointer to the PSK.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully set the PSK. </td></tr>
    <tr><td class="paramname">kThreadError_InvalidArgs</td><td>The PSK is invalid. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afd01649bee7d9b91588e9fcde86e6dce"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::MeshCoP::Dtls::Start </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>aClient</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#ae4549ce46dbb24e3364544f31c344b39">ReceiveHandler</a>&#160;</td>
          <td class="paramname"><em>aReceiveHandler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html#a46b3f173dd41439e6ab6793a3a384035">SendHandler</a>&#160;</td>
          <td class="paramname"><em>aSendHandler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>aContext</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method starts the DTLS service. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aClient</td><td>TRUE if operating as a client, FALSE if operating as a server. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aReceiveHandler</td><td>A pointer to the receive handler. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aSendHandler</td><td>A pointer to the send handler. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aContext</td><td>A pointer to application-specific context.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully started the DTLS service. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a727662d68d1d654c54decad9d8e322f7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::MeshCoP::Dtls::Stop </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method stops the DTLS service. </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully stopped the DTLS service. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/core/meshcop/<a class="el" href="../../de/d6c/dtls_8hpp_source.html">dtls.hpp</a></li>
<li>src/core/meshcop/<a class="el" href="../../d2/d47/dtls_8cpp.html">dtls.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><b>MeshCoP</b></li><li class="navelem"><a class="el" href="../../d0/d5d/classThread_1_1MeshCoP_1_1Dtls.html">Dtls</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:37 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
